package com.hzya.frame;

import com.hzya.frame.nifiapi.model.joingetallcontrollerservice.Component19;
import com.hzya.frame.nifiapi.model.joingetallcontrollerservice.ControllerServices19;
import com.hzya.frame.nifiapi.model.resultNeedModifyController.PortFilterResult;
import com.hzya.frame.nifiapi.operation.INifiBaseOperation;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.List;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame
 * @Project：fw-nifi
 * @name：TestINifiBaseOperation
 * @Date：2025/5/22 17:02
 * @Filename：TestINifiBaseOperation
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = {WebappApplication.class})
public class TestINifiBaseOperation {

    @Autowired
    private INifiBaseOperation iNifiBaseOperation;

    @Test
    public void testGetNeedModifyControllerServicesByProcessGroup() throws Exception {
        try {
            List<ControllerServices19> needModifyControllerServicesByProcessGroup = iNifiBaseOperation.getNeedModifyControllerServicesByProcessGroup("4143d803-0196-1000-968f-b06f55b43a3f");
            System.out.println(needModifyControllerServicesByProcessGroup.size());
            ControllerServices19 controllerServices19 = needModifyControllerServicesByProcessGroup.get(0);
            Component19 component = controllerServices19.getComponent();
            System.out.println(component.getName());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testGetNeedModifyControllerServicesByProcessGroup2() throws Exception {
        try {
            ControllerServices19 czfJwnb9sb = iNifiBaseOperation.getNeedModifyControllerServicesByProcessGroup("4143d803-0196-1000-968f-b06f55b43a3f", "CZFJwnb9sb");
            if (czfJwnb9sb != null && czfJwnb9sb.getComponent() != null) {
                Component19 component = czfJwnb9sb.getComponent();
                String name = component.getName();
                System.out.println(name);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testGetNeedModifyControllerRelationshipByProcessGroup() throws Exception {
        try {
            PortFilterResult needModifyControllerRelationshipByProcessGroup = iNifiBaseOperation.getNeedModifyControllerRelationshipByProcessGroup("41437b87-0196-1000-6951-50e41e75c0da", "f5228bc8-0360-41eb-a640-9f4df953937c");
            System.out.println(needModifyControllerRelationshipByProcessGroup);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
