package com.hzya.frame.nifiapi.operation.impl;

import cn.hutool.core.util.StrUtil;
import com.hzya.frame.nifiapi.config.NifiServiceConfig;
import com.hzya.frame.nifiapi.model.joinbindparametercontexts.BindParameterContextsJoin11;
import com.hzya.frame.nifiapi.model.joinbindparametercontexts.Component11;
import com.hzya.frame.nifiapi.model.joinbindparametercontexts.ParameterContext11;
import com.hzya.frame.nifiapi.model.joinbindparametercontexts.Revision11;
import com.hzya.frame.nifiapi.model.joincontrollerenabled.EnOrDiControllerServices12;
import com.hzya.frame.nifiapi.model.joincontrollerenabled.Revision13;
import com.hzya.frame.nifiapi.model.joincreateconnection.CreateConnection18;
import com.hzya.frame.nifiapi.model.joincreateconnections.CreateConnections18;
import com.hzya.frame.nifiapi.model.joincreateprocessconnection.CreateProcessorConnections;
import com.hzya.frame.nifiapi.model.joincreparamcontext.CreateParamContextJoin;
import com.hzya.frame.nifiapi.model.joinfindneedmodifycontroller.FindNeedModifyController;
import com.hzya.frame.nifiapi.model.joingetallcontrollerservice.ControllerServices19;
import com.hzya.frame.nifiapi.model.joingetallcontrollerservice.GetAllController19;
import com.hzya.frame.nifiapi.model.joingetcontroller.ControllerService12;
import com.hzya.frame.nifiapi.model.joingetcontroller.Revision12;
import com.hzya.frame.nifiapi.model.joinparametercontexts.*;
import com.hzya.frame.nifiapi.model.joinsnippetinstance.SnippetInstanceJoin;
import com.hzya.frame.nifiapi.model.joinsnippets.Snippet;
import com.hzya.frame.nifiapi.model.joinsnippets.SnippetsJoin;
import com.hzya.frame.nifiapi.model.processgroupid.*;
import com.hzya.frame.nifiapi.model.resultNeedModifyController.PortFilterResult;
//import com.hzya.frame.nifiapi.model.resultcreatesnippet.Component152;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.Flow15;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.ProcessGroups15;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.Processors16;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.SnippetInstance15;
import com.hzya.frame.nifiapi.model.resultparametercontexts.ParameterContextsResult;
import com.hzya.frame.nifiapi.model.resultprocessgroupsinfo.ProcessGroupsInfoResult9;
import com.hzya.frame.nifiapi.model.resultprocessgroupsinfo.Revision9;
import com.hzya.frame.nifiapi.model.resultprocessorsinfo.ProcessorsInfo16;
import com.hzya.frame.nifiapi.model.resultprocessorsinfo.Revision16;
import com.hzya.frame.nifiapi.model.resultsnippets.Snippet13;
import com.hzya.frame.nifiapi.model.resultsnippets.SnippetResult13;
import com.hzya.frame.nifiapi.operation.INifiBaseOperation;
import com.hzya.frame.nifiapi.service.NifiApiService;
import com.hzya.frame.nifiapi.util.NifiFilterUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.nifiapi.operation.impl
 * @Project：fw-nifi
 * @name：BaseOperationImpl
 * @Date：2025/5/21 18:07
 * @Filename：BaseOperationImpl
 */
@Repository(value = "BaseOperationImpl")
public class NifiBaseOperationImpl implements INifiBaseOperation {

    Logger logger = LoggerFactory.getLogger(NifiBaseOperationImpl.class);

    @Autowired
    private NifiApiService nifiApiService;

    @Autowired
    private NifiServiceConfig nifiServiceConfig;

    @Autowired
    private NifiFilterUtil nifiFilterUtil;

    @Override
    public String instantiateApp(String appProcessGroupId, String parentProcessGroupId, String copyTargetProcessGroupId) throws Exception {
        String processGroups15Id = null;
        try {
            //创建流程组片段
            //查询目标流程组版本
            ProcessGroupsInfoResult9 processGroups = nifiApiService.getProcessGroups(appProcessGroupId);
            Revision9 revision = processGroups.getRevision();

            Map<String, String> processGroupsMap2 = new HashMap<>();
            processGroupsMap2.put("version", revision.getVersion());//目标流程组版本号

            Map<String, Map<String, String>> processGroupsMap = new HashMap<>();
            processGroupsMap.put(appProcessGroupId, processGroupsMap2);//目标流程组id

            Snippet snippet = new Snippet();
            snippet.setParentGroupId(parentProcessGroupId);//目标流程组id的父流程组id
            snippet.setProcessGroups(processGroupsMap);
            snippet.setProcessors(new HashMap<>());

            SnippetsJoin snippetsJoin = new SnippetsJoin();
            snippetsJoin.setSnippet(snippet);
            SnippetResult13 snippets = nifiApiService.createSnippets(snippetsJoin);
            Snippet13 snippet1 = snippets.getSnippet();

            //2.将片段实例化到指定位置,得到实例化后的应用id
            ProcessGroupsInfoResult9 processGroups2 = nifiApiService.getProcessGroups(copyTargetProcessGroupId);
            Revision9 revision2 = processGroups2.getRevision();

            Map<String, String> processGroupsMap3 = new HashMap<>();
            processGroupsMap3.put("version", revision2.getVersion());//目标流程组版本号

            Map<String, Map<String, String>> processGroupId = new HashMap<>();
            processGroupId.put(copyTargetProcessGroupId, processGroupsMap3);//目标流程组id

            SnippetInstanceJoin snippetInstanceJoin = new SnippetInstanceJoin();
            snippetInstanceJoin.setSnippetId(snippet1.getId());
            SnippetInstance15 snippetInstance = nifiApiService.createSnippetInstance(copyTargetProcessGroupId, snippetInstanceJoin);
            Flow15 flow = snippetInstance.getFlow();
            ProcessGroups15 processGroups15 = flow.getProcessGroups().get(0);
            processGroups15Id = processGroups15.getId();
        } catch (Exception e) {
            throw new Exception(e);
        }
        return processGroups15Id;
    }

    @Override
    public String copyProcessor(String targetProcessorId, String parentProcessGroupId, String copyTargetProcessGroupId) throws Exception {
        String processId = null;
        try {
            //1.处理处理器片段
            //查询目标处理器版本
            ProcessorsInfo16 processor = nifiApiService.getProcessor(targetProcessorId);
            Revision16 revision1 = processor.getRevision();

            //目标处理器版本号
            Map<String, String> processGroupsMap2 = new HashMap<>();
            processGroupsMap2.put("version", revision1.getVersion());

            Map<String, Map<String, String>> processGroupsMap = new HashMap<>();
            processGroupsMap.put(targetProcessorId, processGroupsMap2);//目标流程组id

            Snippet snippet = new Snippet();
            snippet.setParentGroupId(parentProcessGroupId);//目标处理器id的父流程组id
            snippet.setProcessors(processGroupsMap);
            snippet.setProcessGroups(new HashMap<>());//这里真是一个坑，不传抛出空指针异常

            SnippetsJoin snippetsJoin = new SnippetsJoin();
            snippetsJoin.setSnippet(snippet);
            SnippetResult13 snippets = nifiApiService.createSnippets(snippetsJoin);
            Snippet13 snippet1 = snippets.getSnippet();

            //2.实例化片段
            SnippetInstanceJoin snippetInstanceJoin = new SnippetInstanceJoin();
            snippetInstanceJoin.setSnippetId(snippet1.getId());
            SnippetInstance15 snippetInstance = nifiApiService.createSnippetInstance(copyTargetProcessGroupId, snippetInstanceJoin);
            Processors16 processors16 = snippetInstance.getFlow().getProcessors().get(0);
            processId = processors16.getId();
        } catch (Exception e) {
            throw new Exception(e);
        }
        return processId;
    }

    @Override
    public String createParameterContextsBindingProcessGroup(CreateParamContextJoin createParamContextJoin) throws Exception {
        String paramGroupsId = null;
        try {
            //1.创建参数上下文
            ParameterContextsJoin parameterContextsJoin1 = createParamContextJoin.getParameterContextsJoin();
            ParameterContextsResult parameterContexts = nifiApiService.createParameterContexts(parameterContextsJoin1);
            System.out.println(parameterContexts);

            //2.绑定到指定流程组
            //查询指定流程组的详情
            String processGroupsId = createParamContextJoin.getProcessGroupsId();
            ProcessGroupsInfoResult9 processGroups = nifiApiService.getProcessGroups(processGroupsId);
            Revision9 revision = processGroups.getRevision();

            //流程组的版本号
            Revision11 revision11 = new Revision11();
            revision11.setVersion(revision.getVersion());

            //参数上下文对象id
            ParameterContext11 parameterContext11 = new ParameterContext11();
            parameterContext11.setId(parameterContexts.getId());

            //指定的组件对象
            Component11 component11 = new Component11();
            component11.setId(processGroups.getId());
            component11.setParameterContext(parameterContext11);

            BindParameterContextsJoin11 bindParameterContextsJoin11 = new BindParameterContextsJoin11();
            bindParameterContextsJoin11.setComponent(component11);
            bindParameterContextsJoin11.setRevision(revision11);
            ProcessGroupsInfoResult9 processGroupsInfoResult9 = nifiApiService.bindParameterContexts(bindParameterContextsJoin11);
            logger.info("流程组id:{}", processGroupsInfoResult9.getId());
            paramGroupsId = parameterContexts.getId();
        } catch (Exception e) {
            throw new Exception(e);
        }
        return paramGroupsId;
    }

    @Override
    public List<ControllerServices19> getNeedModifyControllerServicesByProcessGroup(String processGroupId) throws Exception {
        String controllerModifyMark = nifiServiceConfig.getControllerModifyMark();
        //1.查找某个流程组内的所有控制器，筛选出带"接口修改标记"的控制器，片段
        List<ControllerServices19> modifiedControllers = new ArrayList<>();
        GetAllController19 allControllerServices = nifiApiService.getAllControllerServices(processGroupId);
        if (allControllerServices != null && allControllerServices.getControllerServices() != null) {
            modifiedControllers = allControllerServices.getControllerServices().stream().filter(service -> service.getComponent() != null && service.getComponent().getComments() != null && service.getComponent().getComments().contains(controllerModifyMark)).collect(Collectors.toList());
        }
        return modifiedControllers;
    }

    @Override
    public ControllerServices19 getNeedModifyControllerServicesByProcessGroup(String processGroupId, String mark) throws Exception {
        //1.查找某个流程组内的所有控制器，筛选出带"接口修改标记"的控制器，片段
        List<ControllerServices19> modifiedControllers = new ArrayList<>();
        GetAllController19 allControllerServices = nifiApiService.getAllControllerServices(processGroupId);
        if (allControllerServices != null && allControllerServices.getControllerServices() != null) {
            modifiedControllers = allControllerServices.getControllerServices().stream().filter(service -> service.getComponent() != null && service.getComponent().getComments() != null && service.getComponent().getComments().contains(mark)).collect(Collectors.toList());
        }
        return modifiedControllers.get(0);
    }

    @Override
    public PortFilterResult getNeedModifyControllerRelationshipByProcessGroup(String processGroupId, String mark) throws Exception {
        try {
            //查询指定流程组
            ProcessGroupsId processGroupsId = nifiApiService.queryFlowProcessGroupsRoot(processGroupId);
            if (processGroupsId != null && processGroupsId.getProcessGroupFlow() != null) {
                ProcessGroupFlow processGroupFlow = processGroupsId.getProcessGroupFlow();
                if (processGroupFlow.getFlow() != null) {
                    Flow flow = processGroupFlow.getFlow();
                    List<InputPorts> inputPorts = nifiFilterUtil.filterPortsByComments(flow.getInputPorts(), mark, "inputPorts");
                    List<OutputPorts> outputPorts = nifiFilterUtil.filterPortsByComments(flow.getOutputPorts(), mark, "outputPorts");
                    return new PortFilterResult(inputPorts, outputPorts);
                }
            }
        } catch (Exception e) {
            throw new Exception(e);
        }
        return new PortFilterResult();
    }

    @Override
    public List<Processors> getFindStateClearMarkProcessor(String processGroupId, String mark) throws Exception {
        List<Processors> filteredProcessors = new ArrayList<>();
        try {
            // 查询指定流程组内的详情
            ProcessGroupsId processGroupsId = nifiApiService.queryFlowProcessGroupsRoot(processGroupId);
            if (processGroupsId != null && processGroupsId.getProcessGroupFlow() != null) {
                ProcessGroupFlow processGroupFlow = processGroupsId.getProcessGroupFlow();
                Flow flow = processGroupFlow.getFlow();
                List<Processors> processors = flow.getProcessors();

                // 过滤 comments 包含 mark 的 Processors
                filteredProcessors = processors.stream().filter(processor ->
                        processor.getComponent() != null
                                && processor.getComponent().getConfig() != null
                                && processor.getComponent().getConfig().getComments() != null
                                && processor.getComponent().getConfig().getComments().contains(mark)).collect(Collectors.toList());
            }
        } catch (Exception e) {
            throw new Exception("未能筛选带有标记的处理器：" + mark, e);
        }
        return filteredProcessors;
    }

    @Override
    public void findNeedModifyControllerAndChangesOccur(FindNeedModifyController findNeedModifyController, boolean isThrowError, boolean enabledAll) throws Exception {
        try {
            //1.得到"接口修改标记"的控制器，并验证入参数量是否匹配
            List<ControllerServices19> needModifyControllerServicesByProcessGroup = getNeedModifyControllerServicesByProcessGroup(findNeedModifyController.getProcessGroupId());

            List<ControllerService12> needModifyController = findNeedModifyController.getNeedModifyController();
            if (needModifyControllerServicesByProcessGroup != null) {
                if ((needModifyControllerServicesByProcessGroup.size() != needModifyController.size()) && isThrowError) {
                    throw new Exception(StrUtil.format("需要接口修改{}个控制器，但接口传了{}个", needModifyControllerServicesByProcessGroup.size(), needModifyController.size()));
                }
            }

            //2.修改指定控制器
            for (ControllerService12 controllerService11 : needModifyController) {
                //查询控制器版本
                ControllerService12 controllerServices = nifiApiService.getControllerServices(controllerService11.getId());
                Revision12 revision = controllerServices.getRevision();

                Revision12 revision12 = new Revision12();
                revision12.setVersion(revision.getVersion());

                controllerService11.setRevision(revision12);
                ControllerService12 controllerService12 = nifiApiService.updateControllerServices(controllerService11.getId(), controllerService11);
                //在传参没有问题的情况下，有控制器id返回即代表修改成功
                logger.info("控制器id:{}", controllerService12.getId());
            }

            //激活当前流程组下的所有控制器
            if (enabledAll) {
                String controllerStatus = "ENABLED";
                batchEnabledControllerServices(findNeedModifyController.getProcessGroupId(), controllerStatus);
            }
        } catch (Exception e) {
            throw new Exception(e);
        }
    }

    @Override
    public void batchCreateProcessorConnections(CreateProcessorConnections createProcessorConnections) throws Exception {
        try {
            String processGroupsId = createProcessorConnections.getProcessGroupsId();
            List<CreateConnections18> createConnections18 = createProcessorConnections.getCreateConnections18();

            for (CreateConnections18 indexCreateConnections : createConnections18) {
                CreateConnection18 processorConnections = nifiApiService.createProcessorConnections(processGroupsId, indexCreateConnections);
                logger.info("连线id：{}", processorConnections.getId());
            }
        } catch (Exception e) {
            throw new Exception(e);
        }
    }

    @Override
    public void batchEnabledControllerServices(String processGroupId, String status) throws Exception {
        try {
            GetAllController19 allControllerServices = nifiApiService.getAllControllerServices(processGroupId);
            if (allControllerServices != null && allControllerServices.getControllerServices() != null) {
                List<ControllerServices19> controllerServices = allControllerServices.getControllerServices();
                for (ControllerServices19 controllerService : controllerServices) {
                    String controllerServicesId = controllerService.getId();

                    //得到控制器服务当前版本
                    ControllerService12 controllerService12 = nifiApiService.getControllerServices(controllerServicesId);
                    Revision12 revision = controllerService12.getRevision();

                    Revision13 revision13 = new Revision13();
                    revision13.setVersion(revision.getVersion());

                    EnOrDiControllerServices12 enOrDiControllerServices = new EnOrDiControllerServices12();
                    enOrDiControllerServices.setState(status);
                    enOrDiControllerServices.setRevision(revision13);
                    ControllerService12 controllerService121 = nifiApiService.enabledOrDisabledControllerServices(controllerServicesId, enOrDiControllerServices);
                    logger.info("控制器服务id：{}", controllerService121.getId());
                }
            }
        } catch (Exception e) {
            throw new Exception(e);
        }
    }

    @Override
    public void clearProcessGroupState(List<String> processGroupId) throws Exception {
        if (processGroupId != null && processGroupId.size() > 0) {
            for (String processGroupIdIndex : processGroupId) {
                //根据流程组id+标识名称，查找需要清理的state处理器
                String relationshipMark = nifiServiceConfig.getRelationshipMark();
                List<Processors> findStateClearMarkProcessor = getFindStateClearMarkProcessor(processGroupIdIndex, relationshipMark);
                for (Processors processors : findStateClearMarkProcessor) {
                    Component2 component = processors.getComponent();
                    if (component != null) {
                        nifiApiService.clearProcessorRequests(component.getId());
                    }
                }
            }
        }
    }
}
